<?php
/* vim: set et ts=4 sw=4 sts=4 ai: */
// +----------------------------------------------------------------------+
// | Comment editing                                                      |
// +----------------------------------------------------------------------+
// | @version $Revision: 1.3 $
// +----------------------------------------------------------------------+

if(!$page) { exit; }

// Only ADMINS can edit a comment
$tripcode = tripcode($_COOKIE["tripcode"]);
$tripcodes = explode(",",ADMINS);
if(!in_array($tripcode,$tripcodes)) {
    $page->fail($ERRORS["tripcodefail"]);
}

$id = $_REQUEST["id"];
if(!is_numeric($id)) { $page->fail($ERRORS["unknownrequest"]); }
$image = getImage($id);
if($image === false) {
	$page->fail($ERRORS["queryfail"]);
}
$thumb = getImageUrl($id,$image["file"],true);
$title = $image["title"] ? $image["title"] : $STRINGS["untitled"];

if($_POST) {

    if($result = updateComment($id,$_POST["comment"])) {
        echo $STRINGS["modifythanks"];
        echo JS_AUTO_CLOSE;
    } else {
        $page->fail($ERRORS["queryfail"]);
    }


} else {

    $tmpl = new HTML_Template_IT(TEMPLATE_DIR,array("use_preg"=>false));
    $tmpl->loadTemplateFile("edit.tmpl");

    $vars = array(
        "id"        => $image["id"],
        "comment"   => htmlspecialchars(stripslashes($image["comment"])),
   );
    $tmpl->setVariable($vars);
    $tmpl->show();
    return;
}
?>
